/* reflex.h */

#ifndef BOOL
#define BOOL int
#define TRUE 1
#define FALSE 0
#endif

typedef void **reflex_ptr;

typedef void (reflex_resize)(int);

void reflex_init(int);
/* Enter number of blocks to allocated */

BOOL reflex_alloc(reflex_ptr,int);
/* Allocate */

void reflex_free(reflex_ptr);
/* Free space */

int reflex_size(reflex_ptr);
/* Return size */

BOOL reflex_extend(reflex_ptr,int);
/* Extend block */

BOOL reflex_midextend(reflex_ptr,int,int);
/* Extend block, and shift data */

void reflex_swap(reflex_ptr,reflex_ptr);
/* Swap two blocks */

void reflex_register_preresize(reflex_resize);
/* Register pre-resize function */

void reflex_register_postresize(reflex_resize);
/* Register post-resize function */

void reflex_register_alloc(reflex_resize);
/* Register allocate_finish function */

void reflex_clearall(void);
/* Clear all reflex blocks */

int reflex_max(void);
/* Returns maximum memory allocatable */
